//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TorchLight0.h"
#include <math.h>
#include <JPEG.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
#define PI       3.141592653
#define Deg2Rad  PI/180.
#define LEN 36
struct MyPoint
{ float x,y;
};
MyPoint pt[LEN];
TPoint  ptDraw[LEN];
int radius = 1; //80;
int lightX=0, lightY=0;

void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{ double deg = 2.*PI/LEN;
  for (int k=0; k<LEN; k++)
     { pt[k].x = radius*cos(k*deg);
       pt[k].y = radius*sin(k*deg);
     }
  Image2->Picture->Bitmap->Width = Image1->Picture->Width;
  Image2->Picture->Bitmap->Height= Image1->Picture->Height;
  Image2->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  Image2->Picture->Bitmap->Canvas->Brush->Bitmap = NULL;
  Image2->Picture->Bitmap->Canvas->Brush->Color = clBlack;
  Image2->Picture->Bitmap->Canvas->Rectangle(0,0,Image1->Picture->Width,Image1->Picture->Height);
  Image2->Picture->Bitmap->Canvas->Brush->Bitmap = Image1->Picture->Bitmap;
  lightX = X; lightY = Y;
  double r,R,cx,cy,x,d,a,b,phi,theta,delta,sine,cosine;
  d = 80;
  phi = 15*Deg2Rad;
  r = d*tan(phi);
  cx = Image1->Picture->Width /2;
  cy = Image1->Picture->Height/2;
  Image2->Picture->Bitmap->Canvas->Rectangle(cx-2,cy-2,cx+2,cy+2);
  R = sqrt( (lightX-cx)*(lightX-cx)+(lightY-cy)*(lightY-cy) );
  x = d*d*(R-r)/(d*d+R*r);
  a = R - x;
  b = r*sqrt(R*R+d*d)/d;
  delta = atan2(lightY-cy, lightX-cx);
  cosine = cos(delta);
  sine   = sin(delta);
  for (int k=0; k<LEN; k++)
     { ptDraw[k].x = a*pt[k].x * cosine - b*pt[k].y * sine   + lightX;
       ptDraw[k].y = a*pt[k].x * sine   + b*pt[k].y * cosine + lightY;
     }
  Image2->Picture->Bitmap->Canvas->Polygon(ptDraw, LEN-1);

  Form1->Canvas->Draw(1,1,Image2->Picture->Graphic);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Load1Click(TObject *Sender)
{
  if ( OpenDialog1->Execute() )
    { Image1->Picture->LoadFromFile(OpenDialog1->FileName);
      Image1->Top  = 1;
      Image1->Left = Image1->Picture->Width + 2;
      Graphics::TBitmap *bmp = new Graphics::TBitmap();
      bmp->Width  = Image1->Picture->Width;
      bmp->Height = Image1->Picture->Height;
      bmp->Canvas->Draw(0,0,Image1->Picture->Graphic);
      Image1->Picture->Bitmap->Assign(bmp);
      Image1->Refresh();
      delete bmp;
    }
}
//---------------------------------------------------------------------------
int btnX, btnY;
bool drawing=false;

void __fastcall TForm1::BitBtn1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if ( Button==mbRight )
    { drawing = true;
      btnX = X;
      btnY = Y;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if ( drawing )
    { int dx = X - btnX;
      int dy = Y - btnY;
      BitBtn1->Left += dx;
      BitBtn1->Top  += dy;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  drawing = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Help1Click(TObject *Sender)
{
  AnsiString msg;
  msg.cat_printf("Torch Light:\n");
  msg.cat_printf("1) Press \"Get Torch\" to start.\n");
  msg.cat_printf("2) Button \"Get Torch\" can be dragged by mouse's right key.");
  ShowMessage(msg);
}
//---------------------------------------------------------------------------
